#ifndef MODEDB_H
#define MODEDB_H

#define REFERENCE_CLOCK 14.31818

enum TVStandard {TVSTD_PAL,TVSTD_PAL_M,TVSTD_NTSC,TVSTD_NULL};
#define TVSTANDARD_COUNT 3

enum TVScale {SCALE_1_1,SCALE_3_4,SCALE_5_4,SCALE_5_6,SCALE_7_8,SCALE_7_10,SCALE_NULL};
#define SCALE_COUNT 6

enum TVFrameRes {FRAME_512_384,FRAME_720_400,FRAME_640_400,FRAME_640_480,FRAME_800_600,FRAME_NULL};
#define FRAMERES_COUNT 5

enum TVOverscan {OS_NORMAL,OS_OVERSCAN,OS_UNDERSCAN,OS_NULL};
#define OVERSCAN_COUNT 3

struct TVOutMode
{
	enum TVStandard TVStd;
	enum TVFrameRes FrameRes;
	enum TVOverscan Overscan;
	int HDisp, VDisp;
	int HTotal, VTotal;
	double Clock;
	int HData,VData;
	enum TVScale Scale;
	int PLL_P2,PLL_D,PLL_N,PLL_P1;
	int StartAV,StartH,StartV;
};

extern struct TVOutMode TV_ModeDB[];

struct TVOutMode *MatchTVMode(enum TVStandard std,enum TVFrameRes fres,
        enum TVOverscan oscn,enum TVScale scale,
        int hdisp, int vdisp, int htotal,int vtotal);

unsigned long CalcFSCI(enum TVStandard tvstd);
char *FrameResText(enum TVFrameRes fr);
char *TVStdText(enum TVStandard std);
char *ScaleText(enum TVScale scale);
char *OverscanText(enum TVOverscan scale);
#endif
